;****   -     
;   4  7  ,
;   74f595,   4
;    ,    *****
;
; - AtTiny15
; -  
;  - 1o.o1.21o
;  - 21.o3.2o1o (!!!!!!!!!!!!!!!!)
; omercury@yandex.ru
;*********************************************
;fuse 
.include "tn15def.inc"
.device ATtiny15
;**********  Variables  ************* 
.include "ADC+4dig_7seg_Var.asm"
;********  End Variables  ***********
.CSEG
.org 0
	rjmp	begin					;
	reti	;rjmp	Ext_INT0				; External Interrupt Request 0
	reti	;rjmp	PCI				; Pin Change Interrupt
	reti	;rjmp	Tim1_CompA		; Timer/Counter1 Compare Match A
	reti	;rjmp	Tim1_OVF		; Timer/Counter1 Overflow
	rjmp	Tim0_OVF		; Timer/Counter0 Overflow
	reti	;rjmp	EERDY			; EEPROM Ready
	reti	;rjmp	ACI				; Analog Comparator Conversion Complete
	reti	;rjmp	ADC_Comp		; ADC Conversion Complete
;********************************************************************************
;	INT_VECTORS_SIZE	= 9	; size in words
;********************************************************************************
;*************************************************
;*                *
;*************************************************
ADC_in:	;	cli							; 
		clr		imp1
		clr		imp2
		ldi		ADCcount,ADCcountCicle		; 
ADC_cicle:
	;	ldi		temp,0b11001011	;INT enable
		ldi		temp,0b11000011	;INT disable
		out		ADCSR,temp			; ()
ADC_wait:
		sbis	ADCSR,ADIF			;   
		rjmp	ADC_wait			;   - 
		in		temp,ADCL			; -  
		add		imp1,temp			;
		in		temp,ADCH			; -  
		adc		imp2,temp			;
		sbi		ADCSR,ADIF			; 
		dec		ADCcount
		brne	ADC_cicle			;
;	    
		ldi		ADCcount,ADCcountCicle/2		; 
ADC_Rot:lsr		imp2			; ( )
		ror		imp1			; ( )
		dec		ADCcount
		brne	ADC_Rot			;
		mov		temp,imp2
		andi	temp,0b00000011	; 
		mov		imp2,temp
	;	sei							; 
		ret
;*************************************************
; 2 
;*************************************************
BinToDecRegTwoByte:
		clr		tmp1
		clr		tmp2
		clr		tmp3
		ldi		cntDec,8*2	;8-16-24-32
Rot21:	rol		imp1		;
		rol		imp2		;
		rol		tmp1	;  0  1
		rol		tmp2	;  2  3
		rol		tmp3	;   4
		dec		cntDec
		brne	Rot22
		ret
;*************************************************
Rot22:	mov		temp1,tmp1
		rcall	DecodeOneByte		; 0  1
		mov		tmp1,temp1
		mov		temp1,tmp2
		rcall	DecodeOneByte		; 2  3
		mov		tmp2,temp1
		mov		temp1,tmp3
		rcall	DecodeOneByte		;  5
		mov		tmp3,temp1
		rjmp	Rot21
;*****************************************************
;    ( )
;*****************************************************
DecodeOneByte:
		ldi		temp,$03
		add		temp,temp1
		sbrc	temp,3
		mov		temp1,temp
		ldi		temp,$30
		add		temp,temp1
		sbrc	temp,7
		mov		temp1,temp
		ret
;*****************************************************
;      ROM
;*****************************************************
LdTable:
		andi	temp,$0F
		ldi		ZL,Low(TableAdr)	;   
		ldi		ZH,High(TableAdr)
		add		ZL,temp				;    
		clr		temp
		adc		ZH,temp
		lsl		ZL					;  2
		rol		ZH
		lpm							;   
		ret
;*************************************************
;     
;   
;*************************************************
Decode:	mov		temp,tmp1	;    1
		rcall	LdTable
		mov		out1,r0
		mov		temp,tmp1	;    2
		swap	temp
		rcall	LdTable
		mov		out2,r0
		mov		temp,tmp2	;    3
		rcall	LdTable
		mov		out3,r0
		mov		temp,tmp2	;    4
		swap	temp
		rcall	LdTable
		mov		out4,r0
		ret
;*************************************************
;     
;   
;*************************************************
DecodeHex:
		mov		temp,imp1	;    1
		rcall	LdTable
		mov		out1,r0
		mov		temp,imp1	;    2
		swap	temp
		rcall	LdTable
		mov		out2,r0
		mov		temp,imp2	;    3
		rcall	LdTable
		mov		out3,r0
		mov		temp,imp2	;    4
		swap	temp
		rcall	LdTable
		mov		out4,r0
		ret
;*************************************************
;   
;*************************************************
DelZero:
		mov		temp,out4
		ser		ADCcount
		cpi		temp,CodZero
		brne	ExitDelZero
		mov		out4,ADCcount
		mov		temp,out3
		cpi		temp,CodZero
		brne	ExitDelZero
		mov		out3,ADCcount
		mov		temp,out2
		cpi		temp,CodZero
		brne	ExitDelZero
		mov		out2,ADCcount
ExitDelZero:
		ret
;*************************************************
;   
;*************************************************
GetVoltage:
		ldi		temp,5		;   5
mpy16u:	clr		tmp3		;clear 2 highest bytes of result
		clr		tmp2
		ldi		ADCcount,16+1	;init loop counter (    2)
m16u_1:
		lsr		temp
		brcc	noad8		;if bit 0 of multiplier set
		add		tmp2,imp1	;Low
		adc		tmp3,imp2	;high
noad8:	ror		tmp3		;shift right result byte 3
		ror		tmp2		;rotate right result byte 2
		ror		tmp1		;rotate result byte 1 and multiplier High
		ror		tmp0		;rotate result byte 0 and multiplier Low
		dec		ADCcount	;decrement loop counter
		brne	m16u_1		;if not done, loop more
		mov		imp2,tmp1	;  
		mov		imp1,tmp0	;    2
		ret
;*****************************************************
;    
;*****************************************************
begin:		; 
;	ldi		temp,(1<<Latch)+(1<<Sck)+(1<<Dout)		; Latch,Sck  Dout  
	ldi		temp,(1<<Sck)+(1<<Latch)		; Latch  Sck  
	out		DDRB,temp			;
;   0
		ldi		temp,0b00000010		; - Fosc/8	(010)
		out		TCCR0,temp
		ldi		temp,(1<<TOIE0)
		out		TIMSK,temp
;***********************************************
		sei		;  
;***********************************************
;	rcall	TestMode
		ldi		Pozic,0b00000001	;   
Main:								;  
;rjmp	ExeMode2		; 
;*************************************************
;    
;*************************************************
TestMode:
		ldi		temp,ADC3		;    
		out		ADMUX,temp		;
		rcall	ADC_in				;   
		lsr		imp2				;   8  
		ror		imp1				;   8  
		lsr		imp2				;   8  
		ror		imp1				;   8  
		mov		temp,imp1
;	ldi	mode,Mode0
		cpi		temp,vMode1		;   
		brsh	ExeMode0		; Vin  - , 
;	brsh	EndTestMode
;	ldi	mode,Mode1
		cpi		temp,vMode2		;   
		brsh	ExeMode1		; Vin  - , 
;	brsh	EndTestMode
;	ldi	mode,Mode2
		cpi		temp,vMode3		;   
		brsh	ExeMode2		; Vin  - , 
;	brsh	EndTestMode
;	ldi	mode,Mode3
		rjmp	ExeMode3

EndTestMode:	;ret
;*************************************************
;     "Mode0"
;*************************************************
ExeMode0:
		ldi		temp,ADC1			; 
		out		ADMUX,temp			;
		rcall	ADC_in				;   
		rcall	BinToDecRegTwoByte	;   
		rcall	Decode				; 
		rcall	DelZero				;  
		rjmp	Main		;  
;*************************************************
;     "Mode1"
;*************************************************
ExeMode1:
		ldi		temp,ADC1			; 
		out		ADMUX,temp			;
		rcall	ADC_in				;   
		rcall	DecodeHex			; 
	;	rcall	DelZero				;  
	ldi	temp,7
	mov	out4,temp
		rjmp	Main		;  
;*************************************************
;     "Mode2"
;*************************************************
ExeMode2:
		ldi		temp,ADC1			; 
		out		ADMUX,temp			;
		rcall	ADC_in				;   
;  
		rcall	GetVoltage
		rcall	BinToDecRegTwoByte	;   
		rcall	Decode				; 
		mov		temp,out4
		andi	temp,0b11111011		; 
		mov		out4,temp
		rcall	DelZero				;  
		rjmp	Main		;  
;*************************************************
;     "Mode3"
;*************************************************
ExeMode3:
		ldi		temp,ADC1			; 
		out		ADMUX,temp			;
		rcall	ADC_in				;   
		lsr		imp2				;   8  
		ror		imp1				;   8  
		lsr		imp2				;   8  
		ror		imp1				;   8  
		rcall	BinToDecRegTwoByte	;   
		rcall	Decode				; 
		rcall	DelZero				;  
		rjmp	Main		;  
;*****************************************************
;         '0'     *
;*****************************************************
Tim0_OVF:
		in		tempSreg,SREG		; 
SendByte:
		ldi		count,8+4			;   
		sbi		DDRB,Dout			;   
SendCikle:
		bst		OutPoz,3			;     (3bit)
		brtc	NoOne				;  ""  "0" - 
		sbi		PORTB,Dout			; Dout  "1"
NoOne:	sbi		PORTB,Sck			; Sck
		cbi		PORTB,Sck
		cbi		PORTB,Dout			;Dout  "0"
		rol		OutSim				;  
		rol		OutPoz				;  
		dec		count				;  
		brne	SendCikle			;   - 
		sbi		PORTB,Latch			; LATGH
		cbi		PORTB,Latch
		cbi		DDRB,Dout			;   
			;       
Poz1:	sbrs	Pozic,0				;  0
		rjmp	Poz2				;,    
		mov		OutSim,out4			;    1
		rjmp	EndPoz				; 
Poz2:	sbrs	Pozic,1				;  1
		rjmp	Poz3				;,    
		mov		OutSim,out3			;    2
		rjmp	EndPoz				; 
Poz3:	sbrs	Pozic,2				;  2
		rjmp	Poz4				;,    
		mov		OutSim,out2			;    3
		rjmp	EndPoz				; 
Poz4:	;sbrs	Pozic,3				;  3
		;rjmp	Poz2				;,    
		mov		OutSim,out1			;    4
		mov		OutPoz,Pozic
		ldi		Pozic,0b00000001	;1 
		rjmp	EndPoz1				; 
EndPoz:	mov		OutPoz,Pozic
		lsl		Pozic				; 
EndPoz1:
		out		SREG,tempSreg		; 
		reti
;*****************************************************
;  
;*****************************************************
TableAdr:
;     **0**
;    *     *
;    6     7
;    *     *
;     **4**
;    *     *
;    3     5
;    *     *
;     **1**   *2*
.db		0b00010100	;0		11101011
.db		0b01011111	;1		10100000
.db		0b01100100	;2		10011011
.db		0b01001100	;3		10110011
.db		0b00001111	;4		11110000
.db		0b10001100	;5		01110011
.db		0b10000100	;6		01111011
.db		0b01011110	;7		10100001
.db		0b00000100	;8		11111011
.db		0b00001100	;9		11110011
.db		0b00000110	;A		11111001
.db		0b10000101	;B		01111010
.db		0b10110100	;C		01001011
.db		0b01000101	;D		10111010
.db		0b10100100	;E		01011011
.db		0b10100110	;F		01011001
